library print_bluetooth_thermal;
import 'package:flutter/services.dart';

Future<List> getBluetooths() async {
  const platform = const MethodChannel('groons.web.app/print');
  List items = new List();
  try {
    final List result = await platform.invokeMethod('bluetoothVinculados');
    print("llego: $result");
    items = result;
  } on PlatformException catch (e) {
    print("Fallo Bluetoorh vinculados: '${e.message}'.");
  }

  return items;
}

Future<String> conectar(String mac) async {

  const platform = const MethodChannel('groons.web.app/print');
  String mac_printen = mac;//"66:02:BD:06:18:7B";
  String result = "false";
  try {
    result = await platform.invokeMethod('conectarImpresora',mac_printen);
    print("llego: $result");
  } on PlatformException catch (e) {
    print("Failed to get battery level: '${e.message}'.");
  }
  return result;
}

Future<String> writeBytes(List<int> bytes) async {

  const platform = const MethodChannel('groons.web.app/print');

  try {
    final String result = await platform.invokeMethod('imprimirTicket',bytes);
    print("llego: $result");
    return result;
  } on PlatformException catch (e) {
    print("Failed to get battery level: '${e.message}'.");
    return "false";
  }

}

Future<String> writeText(String text) async {

  const platform = const MethodChannel('groons.web.app/print');
  //size of 1-5
  //String text = "5/Impresora térmica ñ \n";

  try {
    final String result = await platform.invokeMethod('imprimirTexto',text);
    print("llego: $result");
    return result;
  } on PlatformException catch (e) {
    print("Failed to writeText: '${e.message}'.");
    return "false";
  }
}

Future<int> getNivelBateria() async {

  const platform = const MethodChannel('groons.web.app/print');

  try {
    final int result = await platform.invokeMethod('getBatteryLevel');
    print("llego: $result");
  } on PlatformException catch (e) {
    print("Failed to get battery level: '${e.message}'.");
  }
}
